package org.jboss.as.quickstarts.mdb;

import java.util.logging.Logger;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import javax.annotation.Resource;
import javax.jms.Queue;

@MessageDriven(name = "HelloWorldMDB", mappedName="testqueue", activationConfig = {
		@ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
		@ActivationConfigProperty(propertyName = "destination", propertyValue = "testqueue"),
		@ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge") })
public class HelloWorldMDB implements MessageListener {

	private final static Logger LOGGER = Logger.getLogger(HelloWorldMDB.class
			.toString());
			
	
    @Resource(mappedName="testqueue")
    protected Queue moneyTransferQueue;

	/**
	 * @see MessageListener#onMessage(Message)
	 */
	public void onMessage(Message rcvMessage) {
		TextMessage msg = null;
		try {
			if (rcvMessage instanceof TextMessage) {
				msg = (TextMessage) rcvMessage;
				LOGGER.info("Received Message: " + msg.getText());
			} else {
				LOGGER.warning("Message of wrong type: "
						+ rcvMessage.getClass().getName());
			}			
			if(moneyTransferQueue!=null){
			LOGGER.info("moneyTransferQueue: " + moneyTransferQueue);
			}
		} catch (JMSException e) {
			throw new RuntimeException(e);
		}
	}
}
